#include <stdio.h>
#include <eXosip2/eXosip.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <string.h>

/* bin/sip_reg -r sip:sip.linphone.org:5228 -u sip:SxDx@sip.linphone.org -h */

int main(void)
{
  struct eXosip_t *ctx;
  int i;

  TRACE_INITIALIZE (6, NULL);
  ctx = eXosip_malloc(); if (ctx == NULL) abort();
  if (eXosip_init(ctx)) abort();
  if (eXosip_listen_addr (ctx, IPPROTO_UDP, NULL, 8080, AF_INET, 0)) abort();
//  if (eXosip_listen_addr (ctx, IPPROTO_TCP, NULL, 8080, AF_INET, 0)) abort();
//  if (eXosip_set_option (ctx, EXOSIP_OPT_SET_IPV4_FOR_GATEWAY, "sip.linphone.org:5228")) abort();

eXosip_masquerade_contact (ctx, "86.203.128.21", 8080);
int val=1;
//if (eXosip_set_option (ctx, EXOSIP_OPT_UDP_LEARN_PORT, &val)) abort();
val=0;
//if (eXosip_set_option (ctx, EXOSIP_OPT_USE_RPORT, &val)) abort();

eXosip_lock (ctx);
eXosip_add_authentication_info (ctx, "sxdx2", "sxdx2", "encule!!", NULL, NULL);
eXosip_unlock (ctx);
  eXosip_lock(ctx);
  osip_message_t *reg = NULL;
  int rid = eXosip_register_build_initial_register (ctx, "sip:sxdx2@sip.linphone.org", "sip:sip.linphone.org:5060", NULL, 1800, &reg);
  printf("rid %d\n", rid);
  if (rid<0) abort();
//  osip_message_set_supported (reg, "100rel");
//  osip_message_set_supported (reg, "path");
  i = eXosip_register_send_register (ctx, rid, reg);
  printf("i %d\n", i);
  eXosip_unlock(ctx);

eXosip_event_t *evt;
for (;;)
{
printf("********************* wait event\n");
evt = eXosip_event_wait (ctx, 20, 50);
eXosip_lock(ctx);
eXosip_automatic_action (ctx);
eXosip_unlock(ctx);
if (evt == NULL)
continue;
printf("event %d\n", evt->type);
  switch (evt->type) {
  default: break;
/*
v=0
o=SxDx 337 38 IN IP4 192.168.1.12
s=Talk
c=IN IP4 192.168.1.12
t=0 0
a=ice-pwd:754f051d1e6557f428464800
a=ice-ufrag:3fecdd1a
a=nortpproxy:yes
m=audio 14432 RTP/AVP 111 0 8 101
c=IN IP4 91.121.209.194
a=rtpmap:111 speex/16000
a=fmtp:111 vbr=on
a=rtpmap:0 PCMU/8000
a=rtpmap:8 PCMA/8000
a=rtpmap:101 telephone-event/8000
a=fmtp:101 0-11
a=candidate:1 1 UDP 2130706431 192.168.1.12 7078 typ host
a=candidate:1 2 UDP 2130706430 192.168.1.12 7079 typ host
a=candidate:2 1 UDP 1694498815 86.203.128.21 7078 typ srflx raddr 192.168.1.12 rport 7078
a=candidate:2 2 UDP 1694498814 86.203.128.21 7079 typ srflx raddr 192.168.1.12 rport 7079
a=candidate:484fd6852de33dbb 1 UDP 16777215 91.121.209.194 14432 typ relay raddr 86.203.128.21 rport 7078
a=candidate:484fd6852de33dbb 2 UDP 16777214 91.121.209.194 14433 typ relay raddr 86.203.128.21 rport 7079
a=nortpproxy:yes
*/
  case EXOSIP_CALL_INVITE:
    eXosip_lock (ctx);
    eXosip_call_send_answer (ctx, evt->tid, 180, NULL);
    eXosip_unlock (ctx);
    break;




case EXOSIP_REGISTRATION_SUCCESS:
{
static int sent = 0;
if (sent) break;
sent = 1;
/* INVITE */
osip_message_t *invite;
int cid;
if (eXosip_call_build_initial_invite (ctx, &invite, "<sip:SxDx@sip.linphone.org>",
    "<sip:sxdx2@sip.linphone.org>",
    NULL, // optional route header
    "This is a call for a conversation")) abort();
const char *tmp = "v=0\r\n"
      "o=sxdx2 0 0 IN IP4 86.203.128.21\r\n"
      "s=Talk\r\n"
      "c=IN IP4 86.203.128.21\r\n"
      "t=0 0\r\n"
      "m=audio 8081 RTP/AVP 0\r\n"
      "a=rtpmap:0 speex/16000\r\n"
      "a=fmtp:0 vbr=on\r\n";
osip_message_set_body (invite, tmp, strlen (tmp));
osip_message_set_content_type (invite, "application/sdp");
eXosip_lock (ctx);
cid = eXosip_call_send_initial_invite (ctx, invite);
printf("********************* cid = %d\n", cid);
eXosip_unlock (ctx);
}
  break;

case EXOSIP_CALL_ANSWERED: {
const char *tmp = "v=0\r\n"
      "o=sxdx2 0 0 IN IP4 86.203.128.21\r\n"
      "s=Talk\r\n"
      "c=IN IP4 86.203.128.21\r\n"
      "t=0 0\r\n"
      "m=audio 8081 RTP/AVP 0\r\n"
      "a=rtpmap:0 speex/16000\r\n";
osip_message_t *ack;
if (eXosip_call_build_ack(ctx, evt->did, &ack)) abort();
osip_message_set_body (ack, tmp, strlen (tmp));
osip_message_set_content_type (ack, "application/sdp");
eXosip_lock (ctx);
if (eXosip_call_send_ack(ctx, evt->did, ack)) abort();
eXosip_unlock (ctx);
}
  break;
  }
eXosip_event_free(evt);
}

  return 0;
}
